%It executes @NetGA for a number of times equals to maxnum

%%%%%%%%%%%%%%%%%%%%%%

function AttributeGA(fileinput,fileattributi,T,fileclassi,numclassi,mutationRate,CrossoverFraction,maxGen,PopSize,maxnum)

% fileout=sprintf('%s.ris',fileinput);
% fileout1=sprintf('%s.sol',fileinput);

fileout=sprintf('%s.ris',fileinput);
fileout1=sprintf('%s.sol',fileclassi);

[fid, message] = fopen(fileout,'wt');
[fid1, message] = fopen(fileout1,'wt');

classi=load(fileclassi);

[M] = edgesToadj(fileinput);
figure
plot(graph(M))

numberOfVariables = size(M,1);

M2=zeros(T,numberOfVariables);
features=featToMAtrix(M2,fileattributi);


numberOfVariables = size(M,1);% number of nodes

%Create the Unified Distance Measure Matrix
disp('Create the Unified Distance Measure Matrix');
            distM=zeros(numberOfVariables,numberOfVariables)-1;
            for i1=1:numberOfVariables
                %i1
                for j1=1:numberOfVariables
                    if (i1~=j1 & distM(i1,j1)==-1)
                        f_i=features(:,i1);
                        f_j=features(:,j1);
                        distM(i1,j1)=UnifiedDistanceMeasure(i1,j1,M,f_i',f_j',0.5,0.5,[0.5 0.5],1,1);
                        distM(j1,i1)=distM(i1,j1);
                    else %distM~=-1
                        distM(i1,j1)=distM(j1,i1);
                    end
                end
            end


    

for k=1:numberOfVariables            %for each node, compute the neigbors 
  Neighbor{k} = find(M(k,:));
end

for k=1:numberOfVariables            
    if (Neighbor{k}==0) 
        bestNN(k)=0; %in case the node is isolated
    else
      bestNN(k) = bestNeighbor(k,Neighbor); %compute the best neighbor, i.e. that having the highest number of common neighbors
    end
end


%maxnum=1; %it is the number of times the algorithm is executed
timetot=0;

NMIris = zeros(maxnum,2); %NMIris stores, for each iteration, the maximum NMI value obtained by the method and the corresponding modularity value

MODris = zeros(maxnum,2); %MODris stores, for each iteration, the maximum modularity value obtained by the method and the corresponding NMI value


ARIris=zeros(maxnum,1); %ARI index

F1ris=zeros(maxnum,1); %F-measure


for numtest = 1:maxnum

type create_population.m;

%%
% The custom crossover function takes an individual of the population, and
% returns the children that result from the crossover.
type crossover_cluster.m;

%%
% The custom mutation function takes an individual, which is a clustering, and returns a 
%mutated individual in which the node connectet to a gene at position i is substituted with 
%one of its neighbors.

type mutate_cluster.m;

%%
% We also need a fitness function for the problem. The
% fitness of an individual is the sum of the score of each cluster
% 
type MOcluster_fitness.m;


FitnessFcn = @(x)MOcluster_fitness(x,distM);
 
 
options = gaoptimset('PopulationType', 'custom','PopInitRange', ...
    [1;numberOfVariables]);

Elitecount=(options.PopulationSize*10)/100;

%Update for plotting 3 objective functions - Annalisa%
% objectivesToPlot = [1]; % or whatever two objectives you want
% plotfn = @(options,state,flag)gaplotpareto(options,state,flag,objectivesToPlot);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

options = gaoptimset(options,'CreationFcn',{@create_population, bestNN,Neighbor}, ...
    'CrossoverFcn',{@crossover_cluster,M},...
    'MutationFcn',{@mutate_cluster, mutationRate,Neighbor}, ...
    'PlotFcn', {@plotfun,@gaplotscores,@gaplotscorediversity}, ...
    'SelectionFcn',@selectiontournament, ...
    'Generations',maxGen,'PopulationSize',PopSize, ...
    'StallTimeLimit',2000, ...
'StallGenLimit',10,'Vectorized','off',...
    'UseParallel','always');

tic;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%FUNZIONE CHE LANCIA L'AG - Annalisa %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[x,fval,reason,output,population,scores] = ga(FitnessFcn,numberOfVariables,options);%tra parentesi quadre ? possibile settare i vincoli - Annalisa
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


time=toc;
timetot=timetot+time;



risultato=zeros(1,8);



CC=decodenew(x);
       
numComm=size(CC,2);

%%%%%%%%%%%%%%%%%
for j1=1:numComm
    nodi=CC{j1};
    for j2=1:size(nodi,2)
        cluster(nodi(j2))=j1;
    end
end

            N2=zeros(numComm,numComm);
            for i1=1:numComm-1
                for j1=i1+1:numComm
               N2(i1,j1)=sum(sum(M(CC{i1},CC{j1})));
               N2(j1,i1)=N2(i1,j1);
                end
            end

            vettore_predicted=zeros(numberOfVariables,2);
            for k=1:numberOfVariables
                vettore_predicted(k,1)=k;
                vettore_predicted(k,2)=cluster(k);
            end%%%%%%%%%%%%%%%%%%%%%%%


vettore_indicatore=zeros(1,size(N2,1));
 
for k=1:size(N2,1)
    if(vettore_indicatore(1,k)==0)%controlla che il cluster k non sia stato gi? valutato
    [max_k,z]=max(N2(k,:));
    size_k=size(CC{k},2);
    size_z=size(CC{z},2);
    if(size_k<=size_z)
        num_intraEdges_k=sum(sum(M(CC{k},CC{k})));
        if(num_intraEdges_k<max_k)
            vettore_predicted=includeCommunity(vettore_indicatore,vettore_predicted,k,z);%includi la community k in z
            vettore_indicatore(1,k)=z;
        end
    else %la size minore ? quella del cluster z
        num_intraEdges_z=sum(sum(M(CC{z},CC{z})));
        if(num_intraEdges_z<max_k)
            vettore_predicted=includeCommunity(vettore_indicatore,vettore_predicted,z,k);%includi la  community z in k
             vettore_indicatore(1,z)=k;
        end
    end
    end
end

numclassi_predicted=size(unique(vettore_predicted(:,2)),1);
vettore_predicted(:,2)=reindex(vettore_predicted(:,2));

flags=zeros(1,numclassi_predicted);

for i1=1:numberOfVariables
    v=vettore_predicted(i1,2);
    if (flags(1,v)==1)
    CC_merged{v}=[CC_merged{v} i1];
    else
        CC_merged{v}=[i1];
        flags(1,v)=1;
    end
end


flags2=zeros(1,numclassi);

for i1=1:numberOfVariables
    v=classi(i1,2);
    if (flags2(1,v)==1)
    CC_gt{v}=[CC_gt{v} i1];
    else
        CC_gt{v}=[i1];
        flags2(1,v)=1;
    end
end


fprintf(fid1,'communities of the solution at iteration %d\n',numtest);

for i1=1:size(CC_merged,2) %
    listnodes=CC_merged{i1};
    for j1 = 1: size(listnodes,2)
        fprintf(fid1,'%d ',listnodes(j1));
    end
    fprintf(fid1,'\n');
end
fprintf(fid1,'Number of communities %d\n ',size(CC_merged,2));
    
Modularity = computeMod(CC,M);
Modularity_merged=computeMod(CC_merged,M);

%couple=load(fileclassi);
soluzione=zeros(numberOfVariables,1);%vettore soluzione
for i1=1:size(CC_merged,2)
   listnodes=CC_merged{i1};
   for j1=1:size(listnodes,2)
       soluzione(listnodes(j1),1)=i1;
   end
end
soluzione
[ARI,     F1, ~, ~, ~] = RandIndex(classi(:,2),soluzione);
%NMI_other=NMI_(couple(:,2),soluzione);
Modularity_gt=computeMod(CC_gt,M);
CM_merged=confusionMatrix(CC_merged,classi,numclassi);
%compute the  normalized mutual information 
if numclassi > 0
      CM=confusionMatrix(CC,classi,numclassi); %generate confusion matrix 
       NMI = computeNMI(CM,numberOfVariables);
else NMI =0;
end

if numclassi_predicted > 0
       NMI_merged = computeNMI(CM_merged,numberOfVariables)
else NMI_merged =0;
end
       risultato(numtest,1)=numtest;
       risultato(numtest,2)=fval;
       risultato(numtest,3)=NMI;
       risultato(numtest,4)=Modularity;
       risultato(numtest,5)=NMI_merged;
       risultato(numtest,6)=Modularity_merged;
       risultato(numtest,7)=ARI;
       risultato(numtest,8)=F1;
       
    %end % fine per tutti i ris non duplicati 
   
    
    
%end
fprintf(fid,'result at iteration : %d \n',numtest);
for i1 = 1:size(risultato,1)
    for j1= 1:8
       
            fprintf(fid,'%d ',risultato(i1,j1));
    end
    fprintf(fid,'\n');
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%computes the maximum NMI and modularity obtained among the results
[maxNMI,pos]=max(risultato(:,3));

[maxMOD,pos1]=max(risultato(:,4));

[maxNMI_merged,pos]=max(risultato(:,5))

%qui calcolo Conduttanza, ARI ed F1 corrispondenti alla soluzione con
%massimo NMI
ARI_NMI=risultato(pos,7);
F1_NMI=risultato(pos,8);
[maxMOD_merged,pos1]=max(risultato(:,6));

NMIris(numtest,1)=maxNMI;
NMIris(numtest,2)=maxNMI_merged;
MODris(numtest,1)=maxMOD;
MODris(numtest,2)=maxMOD_merged;
ARIris(numtest,1)=ARI_NMI;
F1ris(numtest,1)=F1_NMI;


end

clear risultato;
clear CC;
clear CM;
clear CC_merged;
clear CM_merged;

%NMItot

fprintf(fid,'NMI tot: \n');
for i = 1:maxnum
    for j= 1:2
       
            fprintf(fid,'%d ',NMIris(i,j));
    end
    fprintf(fid,'\n');
end

fprintf(fid,'MOD tot: \n');
for i = 1:maxnum
    for j= 1:2
       
            fprintf(fid,'%d ',MODris(i,j));
    end
    fprintf(fid,'\n');
end
fprintf(fid,'%d ',timetot);


mediaNMIMerged=mean(NMIris(:,2)); 
stdNMIMerged=std(NMIris(:,2)); 

mediaMODMerged=mean(MODris(:,2));
stdMODMerged=std(MODris(:,2));

mediaARI=mean(ARIris(:,1)); 
stdARI=std(ARIris(:,1)); 

mediaF1=mean(F1ris(:,1)); 
stdF1=std(F1ris(:,1)); 

fprintf(fid,'average modularity: %d \n',mediaMODMerged);
fprintf(fid,'standard deviation of mmodularity: %d \n',stdMODMerged);

fprintf(fid,'average max NMI value : %d \n',mediaNMIMerged);
fprintf(fid,'standard deviation of max NMI : %d \n',stdNMIMerged);
fprintf(fid,'average ARI value corresponding to max NMI : %d \n',mediaARI);
fprintf(fid,'standard deviation of ARI value corresponding to max NMI : %d \n',stdARI);
fprintf(fid,'average F1 value corresponding to max NMI : %d \n',mediaF1);
fprintf(fid,'standard deviation of F1 value corresponding to max NMI : %d \n',stdF1);
fprintf(fid,'%d ',timetot);

fclose(fid); 
end

function [mat] = edgesToadj(fileinput)

couple = load(fileinput);

for i=1:size(couple,1)
    mat(couple(i,1),couple(i,2)) = 1;
    mat(couple(i,2),couple(i,1)) = 1;
    
end
numRow=size(mat,1);
for i=1:numRow
    mat(i,i) = 0;
end
end

%Annalisa - function translating the features file into a features matrix
%Most real-world datasets (e.g. Facebook, Flickr, Phil) have anonimized features in terms of numerical ID (> 0) of a


function CM= confusionMatrix(currCC,classi,numclass)

%classi
%numclass

CM = zeros(numclass,size(currCC,2));

for k=1:size(currCC,2) %
    listnodes=currCC{k};
    for j = 1: size(listnodes,2)
        classe = classi(listnodes(j),2);
        CM(classe,k)=  CM(classe,k)+1;
    end
end
end

%This function compute the modularity of Girvan and Newman
function mod= computeMod(CC,M)

numEdges=sum(sum(M(:,:)));

mod=0;


for k=1:size(CC,2) %
    
    %ls is the number of edges joining nodes of the community k
    %ds is the sum of the degrees of the nodes belonging to the community k
    listnodes=CC{k};
    ls=sum(sum(M(listnodes,listnodes)));
    ds=sum(sum(M(listnodes,:)));
    mod=mod + (ls/numEdges - (ds/(numEdges))^2);
end

end

%questa funzione calcola la normalized mutual information a partire dalla matrice di 
%confusione CM tra il clustering  corrente
%contenuto in CC rispetto ad un risultato noto contenuto in filein.
%numclass ? il numero di clusters effettivi
%CM ? la matrice di confusione calcolata a partire da filein

function NMI= computeNMI(CM,n)

%n=128; %numero di nodi della rete. Per ora fissato a 128 ma dovrebbe essere parametr
NMI = 0.0;
numeratore = 0;

for i=1:size(CM,1) 
    
    Ni = sum(CM(i,:)); %somma gli elementi della riga i
  
    for j = 1: size(CM,2)
       
       if (CM(i,j) ~=0)
         Nj = sum(CM(:,j));  %somma gli elementi della colonna j
         numeratore = numeratore + CM(i,j) * log((CM(i,j)*n)/(Ni*Nj));
       end
    end
end

denom1=0;
for i=1:size(CM,1) 
    
    Ni = sum(CM(i,:)); %somma gli elementi della riga i
    denom1= denom1+ Ni * log(Ni/n);
end

denom2=0;
for j=1:size(CM,2) 
    
    Nj = sum(CM(:,j)); %somma gli elementi della colonna j
    denom2= denom2+ Nj * log(Nj/n);
end
    NMI = -2*numeratore/(denom1 + denom2);
end
function pos=bestNeighbor(node,Neighbor) %trova per ogni nodo il vicino con cui condivide il massimo numero di vicini
maxshared=-1;
pos=0;
%Neighbor{node}
for j=1:size(Neighbor{node},2)
    if (j ~= node)
       vicino=Neighbor{node}(j);
       shared=size(intersect(Neighbor{node},Neighbor{vicino}),2);
       if(shared > maxshared)
        maxshared=shared;
        pos=j;
       end
    end
end
end

function N=computeNumInterclusterEdges(M,C,numComm)
% M ? la matrice di adiacenza del grafo
% C ? la suddivisione in community di ogni nodo, in particolare ? un file
% contenente coppie (ID nodo, community di appartenenza)
% N ? una matrice di dimensioni numComm x numComm dove nell'elemento (i,j)
% ? presente il numero di edges tra il cluster i e il cluster j

N=zeros(numComm,numComm);

%ListComm ? un array contenente per ogni elemento una lista di nodi. Nella posizione
%i-esima c'? la lista di nodi appartenenti alla comunit? i-esima
ListComm=zeros(1,numComm);

classi=load(C);

for i=1:numComm
    listnodes{i}=0;
end

for i=1:size(M,1)
    listnodes{classi(i,2)}=[listnodes{classi(i,2)} classi(i,1)];
end
    
for i=1:numComm-1
    numEl1=size(listnodes{i},2);
    for j=i+1:numComm
        numEl2=size(listnodes{j},2);
   N(i,j)=sum(sum(M(listnodes{i}(2:numEl1),listnodes{j}(2:numEl2))));
   N(j,i)=N(i,j);
    end
end
end

function vettore_predicted=includeCommunity(vettore_indicatore,vettore_predicted,k,z)

if(vettore_indicatore(1,z)~=0)
    z1=vettore_indicatore(1,z);
    for i=1:size(vettore_predicted,1)
    if (vettore_predicted(i,2)==k)
        vettore_predicted(i,2)=z1;
    end
end
else
    for i=1:size(vettore_predicted,1)
    if (vettore_predicted(i,2)==k)
        vettore_predicted(i,2)=z;
    end
    end
end

function [idx] = reindex(idxold)
%rinomina i cluster con etichette crescenti
%size restituiesce per ogni nuova etichetta di cluster il numero di
%elementi di quel cluster
%idxold;
idx = zeros(1,length(idxold));
COMu = unique(idxold);
S = zeros(1,length(COMu));
for l=1:length(COMu)
    S(l) = length(idxold(idxold==COMu(l)));
end
[ size2 INDs] = sort(S,'descend');

for l=1:length(COMu)
    idx(idxold==COMu(INDs(l))) = l;
end

end
end

function F=featToMAtrix(M2,fileinput2)

%couple=load(fileinput2);
triple = load(fileinput2);
F=M2;
%for i=1:size(couple,1)
for i=1:size(triple,1)
    %F(couple(i,2),couple(i,1)) = couple(i,2);
    node_ID=triple(i,1);
    att_1=triple(i,2);
    att_2=triple(i,3);
    F(1,node_ID)=att_1;
    F(2,node_ID)=att_2;
end

end

function d_uv=UnifiedDistanceMeasure(u,v,A,alpha_u,alpha_v,W_attr,W_links,W_alpha,W_t,attType)
%Codice per il calcolo della misura di distanza in "Weighted clustering of
%attributed multi-graphs" (Papadopoulos et al. 2016)

%alpha_u vettore di attributi del nodo u
%alpha_v vettore di attributi del nodo v
%attType=1 se attributo numerico (con valori scalati fra [0, 1]), 0 se attributo categorico
V=size(A,2);

SC_uv=0;
numLivelli=size(A,3);
SCt_uv=zeros(1,numLivelli);
for i=1:numLivelli
    for k=1:V
        if(u~=k)
         w_t_uv_k=A(u,k,i);
        end
         if(v~=k)
              w_t_vv_k=A(v,k,i);
         end
        if(u==k)
        w_t_uv_k=1;
        else
            if(v==k)
        w_t_vv_k=1;
            end
        end
        SCt_uv(i)=SCt_uv(i)+(w_t_uv_k-w_t_vv_k)^2;
    end
    SCt_uv(i);
  SC_uv=SC_uv+W_t(i)*SCt_uv(i);
end


SC_uv=(1/V)*SC_uv;

numAttributi=size(alpha_u,2);
AD_uv=0;
delta_alpha_uv=0;
for i=1:numAttributi
    if(attType==1)
        delta_alpha_uv=(alpha_u(i)-alpha_v(i))^2;
    else
    if(alpha_u(i)==alpha_v(i))
    delta_alpha_uv=0;
    else
    delta_alpha_uv=1;
    end
    end
AD_uv=AD_uv+W_alpha(i)*delta_alpha_uv;
end

d_uv=W_attr*AD_uv+W_links*SC_uv;

end
